//
// Created by LIJING on 2021/11/22.
//

#ifndef SAMI_CORE_SAMI_CORE_ERROR_CODE_H
#define SAMI_CORE_SAMI_CORE_ERROR_CODE_H

#define SAMI_OK 0

#define SAMI_BASE                         100000
#define SAMI_PARAM_ERROR                  (SAMI_BASE + 1)
#define SAMI_NOT_SUPPORT                  (SAMI_BASE + 2)
#define SAMI_NOT_IMPLEMENTATION           (SAMI_BASE + 3)
#define SAMI_JNI_PARSE_ERROR              (SAMI_BASE + 4)
#define SAMI_NOT_SUPPORTED_SAMPLE_RATE    (SAMI_BASE + 5)
#define SAMI_NOT_SUPPORTED_CHANNEL_LAYOUT (SAMI_BASE + 6)
#define SAMI_TOKEN_EXPIRED                (SAMI_BASE + 7)
#define SAMI_TOKEN_PARSE_FAILED           (SAMI_BASE + 8)
#define SAMI_TOKEN_APPKEY_NOT_MATCH       (SAMI_BASE + 9)
#define SAMI_CONTEXT_NOT_INIT             (SAMI_BASE + 10)
#define SAMI_SERVER_REQUEST_FAILED        (SAMI_BASE + 11)
#define SAMI_READ_FILE_FAILED             (SAMI_BASE + 12)
#define SAMI_NOT_ENOUGH_BUFFER_ERROR      (SAMI_BASE + 13)
#define SAMI_BLOCK_ERROR                  (SAMI_BASE + 14)
#define SAMI_IDENTIFI_NO_METHODID         (SAMI_BASE + 15)
#define SAMI_TOKEN_ON_FIND_METHODID       (SAMI_BASE + 16)
#define SAMI_NOT_SUPPORT_PARAM            (SAMI_BASE + 17)
#define SAMI_TOKEN_NOT_SUPPORT_PLATFORM   (SAMI_BASE + 18)
#define SAMI_TOKEN_NOT_SUPPORT_PACKAGE_NAME (SAMI_BASE + 19)

// processor
#define SAMI_PROCESSOR_BASE                    (SAMI_BASE + 10000)
#define SAMI_CREATE_PROCESSOR_FAIL             (SAMI_PROCESSOR_BASE + 1)
#define SAMI_PROCESSOR_NOT_PREPARED            (SAMI_PROCESSOR_BASE + 2)
#define SAMI_PROCESSOR_IN_OUT_NOT_EQUAL        (SAMI_PROCESSOR_BASE + 3)
#define SAMI_PROCESSOR_SET_STATE_FAIL          (SAMI_PROCESSOR_BASE + 4)
#define SAMI_PROCESSOR_JNI_BUFFER_NOT_EQUAL_IN (SAMI_PROCESSOR_BASE + 5)
#define SAMI_PROCESSOR_JNI_OUT_BUFFER_LESS_NEED (SAMI_PROCESSOR_BASE + 6)

// extractor
#define SAMI_EXTRACTOR_BASE         (SAMI_BASE + 20000)
#define SAMI_CREATE_EXTRACTOR_FAIL  (SAMI_EXTRACTOR_BASE + 1)
#define SAMI_RELEASE_EXTRACTOR_FAIL (SAMI_EXTRACTOR_BASE + 2)
#define SAMI_AED_S2S_EXTRACTOR_SPEECH_RATIO_NOT_SATISFY (SAMI_EXTRACTOR_BASE + 3)
#define SAMI_PROCESS_EXTRACTOR_FAIL                     (SAMI_EXTRACTOR_BASE + 4)
#define SAMI_VAD_S2S_EXTRACTOR_SPEECH_RATIO_NOT_SATISFY (SAMI_EXTRACTOR_BASE + 5)

// music dsp context
#define SAMI_MSDP_CONTEXT_BASE                           (SAMI_BASE + 30000)
#define SAMI_MSDP_CONTEXT_NOT_PREPARED                   (SAMI_MSDP_CONTEXT_BASE + 1)
#define SAMI_MDSP_CONTEXT_INVALID_JSON                   (SAMI_MSDP_CONTEXT_BASE + 2)
#define SAMI_MDSP_CONTEXT_INVALID_PATH                   (SAMI_MSDP_CONTEXT_BASE + 3)
#define SAMI_MDSP_CONTEXT_INPUT_CONTEXT_IS_NULL          (SAMI_MSDP_CONTEXT_BASE + 4)
#define SAMI_MDSP_CONTEXT_EMPLACE_PARAMETER_EVENT_FAILED (SAMI_PROCESSOR_BASE + 5)

// 3a & ygg
#define SAMI_PROCESS_3A_BASE               (SAMI_BASE + 40000)
#define SAMI_PROCESS_RNNOISE_ERROR         (SAMI_PROCESS_3A_BASE + 1)
#define SAMI_PROCESS_TCNDENOISE_ERROR      (SAMI_PROCESS_3A_BASE + 2)
#define SAMI_LOAD_AEC_MODEL_ERROR          (SAMI_PROCESS_3A_BASE + 3)
#define SAMI_PROCESS_SPEECH_TRACKING_ERROR (SAMI_PROCESS_3A_BASE + 4)
#define SAMI_YGG_BASE                      (SAMI_BASE + 42000)

// sami engine
/*****************************/
#define SAMI_ENGINE_BASE                     (SAMI_BASE + 50000)
#define SAMI_ENGINE_CREATE_ERROR             (SAMI_ENGINE_BASE + 1)
#define SAMI_ENGINE_GETOUTPUT_ERROR          (SAMI_ENGINE_BASE + 2)
#define SAMI_ENGINE_FORWARD_ERROR            (SAMI_ENGINE_BASE + 3)
#define SAMI_ENGINE_START_EXECUTOR_ERROR     (SAMI_ENGINE_BASE + 4)
#define SAMI_ENGINE_UNSUPPORTED_BLOCK_ERROR  (SAMI_ENGINE_BASE + 5)
#define SAMI_ENGINE_GETOUTPUT_NO_OUTPUT      (SAMI_ENGINE_BASE + 6)
#define SAMI_ENGINE_INPUT_UNCOMPATIBLE_ERROR (SAMI_ENGINE_BASE + 7)
#define SAMI_ENGINE_GETOUTPUT_PARAM_ERROR    (SAMI_ENGINE_BASE + 8)
#define SAMI_ENGINE_INPUT_NEED_MORE_DATA     (SAMI_ENGINE_BASE + 9)
#define SAMI_ENGINE_QUERY_PARAM_ERROR        (SAMI_ENGINE_BASE + 10)
#define SAMI_ENGINE_FLUSH_ERROR              (SAMI_ENGINE_BASE + 11)
#define SAMI_ENGINE_PREPARE_ERROR            (SAMI_ENGINE_BASE + 12)

//tob
#define SAMI_TOB_BASE      (SAMI_BASE + 60000)
#define SAMI_TOB_AUTH_FAIL (SAMI_TOB_BASE + 1)

// client
#define SAMI_CLIENT_BASE         (SAMI_BASE + 70000)
#define SAMI_CLIENT_STATE_ERROR  (SAMI_CLIENT_BASE + 1);
#define SAMI_CLIENT_START_FAILED (SAMI_CLIENT_BASE + 2);
#define SAMI_CLIENT_STOP_FAILED  (SAMI_CLIENT_BASE + 3);
#define SAMI_CLIENT_SEND_FAILED  (SAMI_CLIENT_BASE + 4);
#define SAMI_CLIENT_BASE64_ENCODE_FAILED  (SAMI_CLIENT_BASE + 5);

// jni
#define SAMI_JNI_BASE                   (SAMI_BASE + 80000)
#define SAMI_JNI_CLASS_NOT_FOUND        (SAMI_JNI_BASE + 1);
#define SAMI_JNI_METHOD_NOT_FOUND       (SAMI_JNI_BASE + 2);
#define SAMI_JNI_FIELD_NOT_FOUND        (SAMI_JNI_BASE + 3);

// speech assistant
#define SAMI_SPEECH_ASSISTANT_BASE                          (SAMI_BASE + 90000)
#define SAMI_SPEECH_ASSISTANT_MODEL_PATH_ERROR              (SAMI_SPEECH_ASSISTANT_BASE + 1);
#define SAMI_SPEECH_ASSISTANT_LOAD_MODEL_PATH_ERROR         (SAMI_SPEECH_ASSISTANT_BASE + 2);

// io
#define SAMI_IO_BASE                       (SAMI_BASE + 95000)
#define SAMI_IO_FILE_SOURCE_CREATE_ERROR   (SAMI_IO_BASE + 1)
#define SAMI_IO_AUDIO_ENCODER_CREATE_ERROR (SAMI_IO_BASE + 2)

// karaoke
#define SAMI_KARAOKE_BASE                                (SAMI_BASE + 100000)
#define SAMI_KARAOKE_IMPL_ERROR                          (SAMI_KARAOKE_BASE + 1)
#define SAMI_KARAOKE_GRAPH_STATE_ERROR                   (SAMI_KARAOKE_BASE + 2)
#define SAMI_KARAOKE_PARAM_ERROR                         (SAMI_KARAOKE_BASE + 3)
#define SAMI_KARAOKE_CONTEXT_ERROR                       (SAMI_KARAOKE_BASE + 4)
#define SAMI_KARAOKE_RECORD_PRE_PROCESS_ERROR            (SAMI_KARAOKE_BASE + 5)
#define SAMI_KARAOKE_RECORD_CREATE_AUDIO_FILE_FAILED     (SAMI_KARAOKE_BASE + 6)
#define SAMI_KARAOKE_RECORD_AUDIO_FILE_ERROR             (SAMI_KARAOKE_BASE + 7)
#define SAMI_KARAOKE_RECORD_GET_TIME_ALIGN_RESULT_FAILED (SAMI_KARAOKE_BASE + 8)
#define SAMI_KARAOKE_RECORD_GET_SING_SCORE_RESULT_FAILED (SAMI_KARAOKE_BASE + 9)
#define SAMI_KARAOKE_RECORD_GET_LOUDNESS_RESULT_FAILED   (SAMI_KARAOKE_BASE + 10)
#define SAMI_KARAOKE_EDIT_AUDIO_FILE_FORMAT_NOT_SUPPORT  (SAMI_KARAOKE_BASE + 11)
#define SAMI_KARAOKE_EDIT_PARSE_JSON_ERROR               (SAMI_KARAOKE_BASE + 12)
#define SAMI_KARAOKE_EDIT_VOCAL_FILE_INVAILID            (SAMI_KARAOKE_BASE + 13)
#define SAMI_KARAOKE_EDIT_DENOISE_PROCESSER_ERROR        (SAMI_KARAOKE_BASE + 14)
#define SAMI_KARAOKE_EDIT_LOUDNORM_PROCESSER_ERROR       (SAMI_KARAOKE_BASE + 15)
#define SAMI_KARAOKE_EDIT_EFFECT_PROCESSER_ERROR         (SAMI_KARAOKE_BASE + 16)
#define SAMI_KARAOKE_EDIT_BYTETUNER_PROCESSER_ERROR      (SAMI_KARAOKE_BASE + 17)

#define SAMI_VOP_BASE                                    (SAMI_BASE + 110000)
#define SAMI_VOP_UNINITIALIZED_ERROR                     (SAMI_VOP_BASE + 1)
#define SAMI_VOP_STATE_ERROR                             (SAMI_VOP_BASE + 2)
#define SAMI_VOP_LOAD_MODEL_PATH_ERROR                   (SAMI_VOP_BASE + 3)
#define SAMI_VOP_SAVE_FILE_ERROR                         (SAMI_VOP_BASE + 4)
#define SAMI_VOP_INTERNAL_VALUE_ERROR                    (SAMI_VOP_BASE + 5)
#define SAMI_VOP_ASR_NO_RESULT_ERROR                     (SAMI_VOP_BASE + 6)
#define SAMI_VOP_RESAMPLE_ERROR                          (SAMI_VOP_BASE + 7)

#endif  //SAMI_CORE_SAMI_CORE_ERROR_CODE_H
